unit fs_S1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,
  StdCtrls, ComCtrls, Tabnotbk, Buttons,
  Db,
  DBTables, fs_ipascal, fs_iinterpreter, fs_synmemo, Menus, Spin;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel3: TPanel;
    TN1: TTabbedNotebook;
    Timer1: TTimer;
    Panel4: TPanel;
    fsSyntaxMemo1: TfsSyntaxMemo;
    Panel2: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    Query1: TQuery;
    Database1: TDatabase;
    OD1: TOpenDialog;
    SD1: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);

  private
    { Private declarations }
    itsFirst : boolean;

  public
    { Public declarations }

  end;

var
  Form1: TForm1;
  MainDir : string;

Type  
  saTypeCodeError   = word;
  saType_UnSimb     = set of Char;

function GetIntegerFromString99(UnSimb : saType_UnSimb; S:String;Num : integer) : integer;

implementation

uses Form_Script;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  MainDir:=ExtractFilePath(ParamStr(0));
  itsFirst :=FALSE;
  Timer1.Enabled:=TRUE;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=TRUE;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=FALSE;
  if not itsFirst then begin
     itsFirst :=TRUE;
     Timer1.Interval:=1000;
     WindowState:=wsMaximized;
     TN1.PageIndex:=0;
  end;
  Timer1.Enabled:=TRUE;
end;

procedure TForm1.SpeedButton6Click(Sender: TObject);
begin
 fsSyntaxMemo1.Lines.Clear;
 fsSyntaxMemo1.Lines.ADD('');
 fsSyntaxMemo1.Lines.ADD('');
 fsSyntaxMemo1.Lines.ADD('BEGIN');
 fsSyntaxMemo1.Lines.ADD('');
 fsSyntaxMemo1.Lines.ADD('END.');
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
Var
  nLine,nCol : integer;
  Sx : string;
begin
 Form_fsScript.InitialScript_BaseFunc;
 Form_fsScript.fsScript1.Lines.Assign(fsSyntaxMemo1.Lines);
 if Form_fsScript.fsScript1.Compile then begin
    ShowMessage('Ok');
 end
 else begin
    nLine:=GetIntegerFromString99([':'],Form_fsScript.fsScript1.ErrorPos,1);
    nCol:=GetIntegerFromString99([':'],Form_fsScript.fsScript1.ErrorPos,2);
    fsSyntaxMemo1.SetPos(nCol,nLine);
    ShowMessage('Error in '+Form_fsScript.fsScript1.ErrorPos+' -> '+Form_fsScript.fsScript1.ErrorMsg);
    fsSyntaxMemo1.SetFocus;
 end;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  Form_fsScript.fsScript1.Execute;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
Var
  nLine,nCol : integer;
  Sx : string;
begin
 Form_fsScript.InitialScript_BaseFunc;
 Form_fsScript.fsScript1.Lines.Assign(fsSyntaxMemo1.Lines);
 if Form_fsScript.fsScript1.Compile then begin
    Form_fsScript.fsScript1.Execute;
 end
 else begin
    nLine:=GetIntegerFromString99([':'],Form_fsScript.fsScript1.ErrorPos,1);
    nCol:=GetIntegerFromString99([':'],Form_fsScript.fsScript1.ErrorPos,2);
    fsSyntaxMemo1.SetPos(nCol,nLine);
    ShowMessage('Error in '+Form_fsScript.fsScript1.ErrorPos+' -> '+Form_fsScript.fsScript1.ErrorMsg);
    fsSyntaxMemo1.SetFocus;
 end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  OD1.InitialDir:=ExtractFilePath(OD1.FileName);
  if length(OD1.InitialDir)<=0 then OD1.InitialDir:=MainDir;
  if OD1.Execute then begin
     fsSyntaxMemo1.Lines.LoadFromFile(OD1.FileName);
     SD1.FileName:=OD1.FileName;
  end;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  SD1.InitialDir:=ExtractFilePath(SD1.FileName);
  if length(SD1.InitialDir)<=0 then SD1.InitialDir:=MainDir;
  if SD1.Execute then begin
     fsSyntaxMemo1.Lines.SaveToFile(SD1.FileName);
     OD1.FileName:=SD1.FileName;
  end;
end;







//***********************************************
//***********************************************
//***********************************************
//   

procedure rtrim(var S:String);
{   S  }
var
  m,i : integer;
begin
  i:=0;
  while i=0 do
    begin
      m:=length(s);
      if m>0 then begin
         if s[m]<>' ' then i:=1;
         if s[m]=' ' then delete(s,m,1);
      end;
      if m<=0 then i:=1;
  end;
end;

procedure ltrim(var S:String);
{   S  }
var
  m,i : integer;
begin
  i:=0;
  while i=0 do
    begin
      m:=length(s);
      if m>0 then begin
         if s[1]<>' ' then i:=1;
         if s[1]=' ' then delete(s,1,1);
      end;
      if m<=0 then i:=1;
  end;
end;

procedure AllTrim(var S:String);
{   S    }
begin
  rtrim(S);
  ltrim(S);
end;

procedure rtrimUnSimb(UnSimb : saType_UnSimb;Var Stro:String);
var
  m,i : integer;
begin
  i:=0;
  while i=0 do
    begin
      m:=length(stro);
      if m>0 then begin
         if not (stro[m] in UnSimb) then i:=1;
         if (stro[m] in UnSimb) then delete(stro,m,1);
      end;
      if m<=0 then i:=1;
  end;
end;

procedure ltrimUnSimb(UnSimb : saType_UnSimb;Var Stro:String);
var
  m,i : integer;
begin
  i:=0;
  while i=0 do
    begin
      m:=length(stro);
      if m>0 then begin
         if not (stro[1] in UnSimb) then i:=1;
         if (stro[1] in UnSimb) then delete(stro,1,1);
      end;
      if m<=0 then i:=1;
  end;
end;

procedure AlltrimUnSimb(UnSimb : saType_UnSimb;Var Stro:String);
begin
  rtrimUnSimb(UnSimb,Stro);
  ltrimUnSimb(UnSimb,Stro);
end;

function RtrimUnSimb99(UnSimb : saType_UnSimb;S:String) : string;
begin
  Result:=S;
  RtrimUnSimb(UnSimb,Result);
end;

function LtrimUnSimb99(UnSimb : saType_UnSimb;S:String) : string;
begin
  Result:=S;
  LtrimUnSimb(UnSimb,Result);
end;

function AlltrimUnSimb99(UnSimb : saType_UnSimb;S:String) : string;
begin
  Result:=S;
  AlltrimUnSimb(UnSimb,Result);
end;

procedure GiveMe_OneSlovo_FromStr(UnSimb : saType_UnSimb;
                                  Xb : String;
                                  NomSlovo:byte;
                                  Var NN:integer;
                                  Var Rez : String;
                                  Var Cod_Err:saTypeCodeError);
Var
  Yes_Vix1,Yes_Vix,i,m,mm,j,k : integer;
  Xa,Buf : String;
begin
  NN:=0;
  Xa:=Xb;
  AllTrim(Xa);
  AllTrimUnSimb(UnSimb,Xa);
  AllTrim(Xa);
  Rez:='';
  Cod_Err:=0;
  if NomSlovo<=0 then begin
     Rez:=Xa;
     Cod_Err:=0;
  end;
  if NomSlovo>0 then begin
     m:=Length(Xa);
     if m<=0 then Cod_Err:=1;
     if m>0 then begin
        Yes_Vix:=0;
        k:=0;
        j:=0;
        i:=0;
        while Yes_Vix=0 do
          begin
            i:=j;
            Buf:='';
            Yes_Vix1:=0;
            while Yes_Vix1=0 do
              begin
                i:=i+1;
                if i<=m then begin
                   if not (Xa[i] in UnSimb) then begin
                      if NN<=0 then NN:=i;
                      Buf:=Buf+Xa[i];
                   end
                   else begin
                      j:=i;
                      Yes_Vix1:=1;
                   end;
                end
                else begin
                   j:=i;
                   Yes_Vix1:=1;
                   Yes_Vix:=1;
                   Cod_Err:=2;
                end;
            end;
            mm:=Length(Buf);
            if mm>0 then begin
               k:=k+1;
               if k<>NomSlovo then NN:=0;
               if k=NomSlovo then begin
                  Rez:=Buf;
                  Yes_Vix:=1;
                  Cod_Err:=0;
               end;
            end;
        end;
     end;
  end;
  AllTrim(Rez);
  mm:=Length(Rez);
  if mm>0 then Cod_Err:=0;
end;

function GetWordFromString(UnSimb : saType_UnSimb;
                           S:String;Num : integer;
                           Var SRes:String) : Boolean;
Var
  NN : integer;
  CodErr:saTypeCodeError;
  mmm : integer;
begin
  NN:=0;
  GetWordFromString:=FALSE;
  SRes:='';
  AllTrim(S);
  mmm:=Length(S);
  if mmm>0 then begin
     GiveMe_OneSlovo_FromStr(UnSimb,S,Num,NN,SRes,CodErr);
     if CodErr=0 then begin
        GetWordFromString:=TRUE;
     end;
  end;
end;

function GetIntegerFromString99(UnSimb : saType_UnSimb; S:String;Num : integer) : integer;
Var
  S1 : string;
  Res : integer;
begin
  Result:=0;
  if GetWordFromString(UnSimb, S, Num, S1) then begin
     AllTrim(S1);
     Val(S1,Result,Res);
     if Res<>0 then Result:=0;
  end;
end;

//***********************************************
//***********************************************
//***********************************************



end.





